Module java.compiler
Package javax.lang.model.util

## Class AbstractElementVisitor9<R,P>

- java.lang.Object
- - javax.lang.model.util.AbstractElementVisitor6<R,P>
  - - javax.lang.model.util.AbstractElementVisitor7<R,P>
    - - javax.lang.model.util.AbstractElementVisitor8<R,P>
      - - javax.lang.model.util.AbstractElementVisitor9<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  ElementVisitor<R,P>

    @SupportedSourceVersion(RELEASE_9)
    public abstract class AbstractElementVisitor9<R,P>
    extends AbstractElementVisitor8<R,P>

A skeletal visitor of program elements with default behavior appropriate for the `RELEASE_9` source version.

WARNING: The `ElementVisitor` interface implemented by this class may have methods added to it in the future to accommodate new, currently unknown, language structures added to future versions of the Java™ programming language. Therefore, methods whose names begin with `"visit"` may be added to this class in the future; to avoid incompatibilities, classes which extend this class should not declare any instance methods with names beginning with `"visit"`.

When such a new visit method is added, the default implementation in this class will be to call the `visitUnknown` method. A new abstract element visitor class will also be introduced to correspond to the new language level; this visitor will have different default behavior for the visit method in question. When the new visitor is introduced, all or portions of this visitor may be deprecated.

Since:
  9
See Also:
  `AbstractElementVisitor6`, `AbstractElementVisitor7`, `AbstractElementVisitor8`

### Constructor Summary

Constructors
`protected` `AbstractElementVisitor9()` Constructor for concrete subclasses to call.

### Method Summary

All Methods Instance Methods Abstract Methods
`abstract R` `visitModule(ModuleElement t, P p)` Visits a `ModuleElement` in a manner defined by a subclass.

### Methods inherited from class javax.lang.model.util.AbstractElementVisitor6

`visit, visit, visitUnknown`

### Methods inherited from interface javax.lang.model.element.ElementVisitor

`visitExecutable, visitPackage, visitType, visitTypeParameter, visitVariable`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### AbstractElementVisitor9

    protected AbstractElementVisitor9()

Constructor for concrete subclasses to call.

### Method Detail

#### visitModule

    public abstract R visitModule(ModuleElement t,
                                  P p)

Visits a `ModuleElement` in a manner defined by a subclass.

Specified by:
  `visitModule` in interface `ElementVisitor<R,P>`
Overrides:
  `visitModule` in class `AbstractElementVisitor6<R,P>`
Parameters:
  `t` - the element to visit
  `p` - a visitor-specified parameter
Returns:
  the result of the visit as defined by a subclass